Subject: Re: Trouble with DLL and file (com port) IO
From: "R. Steve McKown" <[email-masked]>
To: [email-masked]
Cc: "Dave Korn" <[email-masked]>
Date: Thu, 7 Dec 2006 12:10:53 -0700
List-Id: <cygwin.cygwin.com>

On Thursday 07 December 2006 09:07 am, Dave Korn wrote:
> On 07 December 2006 15:54, R. Steve McKown wrote:
> > On Wednesday 06 December 2006 03:13 pm, Dave Korn wrote:
> >> On 06 December 2006 17:01, R. Steve McKown wrote:
> >>> Th extension accepts a file descriptor to an open serial port, uses the
> >>> cygwin get_osfhandle() function to get the corresponding HANDLE, calls
> >>> the DLL function, then returns.  When run, python core dumps somewhere
> >>> between ...
> >>
> >>   Go research what those decorations actually signify.  Here's some
> >> terms to help get you started at Google:  cdecl, stdcall, fastcall. 
> >> Actually, nevermind google, you may as well go straight to MSDN.
> >
> > The dll header file defines the functions using the WINAPI definition,
> > which appears to map to __stdcall, so I thought the compiler already had
> > the right information in this regard.  I'll research over at MSDN; thank
> > you.
>
>   It's about a hundred-to-one on that what's going on here is a
> disagreement between caller and callee about whose job it is to clean up
> the stack.

And it was.  I had defined a typedef for casting the function pointer returned 
from dlsym(), and it did not carry the proper call attributes.  The test code 
is now working.  Thanks for the assist!

> >>   The only other obvious mistake was spamming everyone on the list with
> >> a couple of hundred kb of completely useless crud ...
> >
> > I posted an apology and a correction within 10 minutes after posting an
> > attachment containing build products, which caused its massive size.  I
> > can't blame you for busting my chops anyway; it was a bone-headed
> > oversight.
>
>   For the avoidance of doubt: that paragraph was meant to be read to
> oneself whilst imagining a bemused tone of voice, rather than a harsh and
> aggressive one.
>
>   However, if you do it again, I'll drop a hippo on you!

8^D

Best,
Steve

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/